/***************************************************************************
 *   Copyright (C) 2009 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef AUTOROTATION_H
#define AUTOROTATION_H

#include <QWidget>
#include <QtGui>
#include <QSystemTrayIcon>
#include <QCloseEvent>

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QPixmap>
#include <QLabel>
#include <QTimer>
#include <QFile>
#include "input_event.h"
#include <QPainter>
#include <X11/extensions/Xrandr.h>
#include <X11/Xlib.h>
#include <QPushButton>
#include <omcheckbutton.h>
#include <ominfobox.h>
#include <omdialogbuttons.h>
/**
	@author Rico Rommel <rico@bierrommel.de>
*/
class AutoRotation : public QWidget
{
Q_OBJECT
public:
    AutoRotation(QWidget *parent = 0);

    ~AutoRotation();

protected:
    QVBoxLayout *VLayout;
    QTimer *Timer;
    qreal angle, oldangle;
    struct input_event ev;
    int evsize;
    char * evdata;
    QFile * evFile;
    double absa[4];
    QStringList AxisList;
    Display * XDisplay;
    int XScreen;
    Rotation XRotation;
    XRRScreenConfiguration * XConfig;
    int current_Xsize;
    Window rootWindow;
    int rot, newrot;
    bool isWaiting;
    QSystemTrayIcon * systrayicon;
    OMCheckButton * CheckButton;
    QStringList OnOffString;
    QString IconBasePath;
    OMInfoBox * InfoBox;
    QSettings * Settings;
    void closeEvent ( QCloseEvent * event );
    OMDialogButtons * DialogButtons;

protected slots:
    void readAccelerometer();
    void rotateScreen();
    void iconActivated(QSystemTrayIcon::ActivationReason);
    void CheckButtonClicked(bool);
    void DialogButtonClicked(QFlags<OMFlags::Flag> button);

};

#endif
