/***************************************************************************
 *   Copyright (C) 2009 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef idlehandler_h
#define idlehandler_h

#include <QMainWindow>
#include <QSystemTrayIcon>
#include <QCloseEvent>
#include <QtGui>
#include <QDBusConnection>
#include <QDBusInterface>
#include <QTabWidget>
#include <QLabel>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include "devinterface.h"
#include "appinterface.h"
#include "config.h"
#include "qstatesettings.h"
#include "qtablehead.h"
#include "btdeviceinterface.h"
#include <omusageinterface.h>

class IdleHandler : public QWidget
{
     Q_OBJECT

public:
    IdleHandler(QDBusConnection *SessionBus);
    ~IdleHandler();
    void createWiFiInterface();
protected:
    QSystemTrayIcon *systrayicon;
    QPushButton *QuitButton;
    QPushButton *CloseButton;
    QPushButton *SaveButton;
    DeviceInterface *USB;
    DeviceInterface *GPS;
    DeviceInterface *CALL;
    DeviceInterface *WiFi;
    AppInterface *APP[MAXAPPS];
    QDBusInterface *idleinterface, *displayinterface;
    OMUsageInterface *usageinterface;
    QStringList idlestates;
    QSettings *settings;
    QTabWidget * tabView;
    QWidget  *tabWidget[3];
    QStateSettings * StateSettings[6];
    QTablehead * SettingsTableHead;
    QGridLayout * MainLayout;
    QHBoxLayout * QuitCloseLayout;
    QVBoxLayout * TabLayout[3];
    BTDeviceInterface * BT;
    void closeEvent ( QCloseEvent * event );
    virtual void resizeEvent( QResizeEvent *event);
    void makeDBUSConnection();
    void createUSBInterface();
    void createGPSInterface();
    void createCALLInterface();
    void createAppInterface( QWidget *tab );
    void createStatesettings();
    void createBTInterface();

protected slots:
    void iconActivated(QSystemTrayIcon::ActivationReason);
    void IdleStateChanged(QString state);
    void saveSettings();

public slots:
    bool activate();
signals:
    void quitApp();
};

#endif