/***************************************************************************
 *   Copyright (C) 2009 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "qtablehead.h"
 #include <QResizeEvent>

QTablehead::QTablehead(QStringList items, QWidget *parent )
 : QWidget(parent)
{
	int count = items.count();
	Item = (QLabel**)malloc( sizeof(QLabel*) * count);

	Layout = new QGridLayout();
	Layout->setSpacing(SPACING);
	Layout->setContentsMargins(0,0,0,0);


	int n;

	for ( n = 0; n < count; n++) {
		Item[n] = new QLabel(items.at(n), this);
		Item[n]->setFrameShape(QFrame::Box);
		Layout->addWidget( Item[n],0,n );
		}

	setLayout( Layout );
}


QTablehead::~QTablehead()
{
	free(Item);

}

void QTablehead::resizeEvent( QResizeEvent *event)
{

	int x = event->size().width() * SETTINGSSTATEWIDTH / 100;
	Layout->setColumnMinimumWidth(0, x);

}
